#include "stdafx.h"
#include "clipboard.hpp"


std::wstring Clipboard::getFormatName(UINT fmt)
{
#define STDFMT(x)  case x: return L#x;

    if (fmt >= 0xc000 && fmt <= 0xffff) {
        const int bufLen = MAX_PATH;
        wchar_t buf[bufLen];
        if (GetClipboardFormatName(fmt, buf, bufLen))
            return buf;
        else
            return L"(unknown)";
    }
    else if (fmt >= CF_GDIOBJFIRST && fmt <= CF_GDIOBJLAST) {
        return L"CF_GDIOBJ<n>";
    }
    else if (fmt >= CF_PRIVATEFIRST && fmt <= CF_PRIVATELAST) {
        return L"CF_PRIVATE<n>";
    }
    else {
        switch (fmt) {
            STDFMT(CF_BITMAP)
            STDFMT(CF_DIB)
            STDFMT(CF_DIBV5)
            STDFMT(CF_DIF)
            STDFMT(CF_DSPBITMAP)
            STDFMT(CF_DSPENHMETAFILE)
            STDFMT(CF_DSPMETAFILEPICT)
            STDFMT(CF_DSPTEXT)
            STDFMT(CF_ENHMETAFILE)
            STDFMT(CF_HDROP)
            STDFMT(CF_LOCALE)
            STDFMT(CF_METAFILEPICT)
            STDFMT(CF_OEMTEXT)
            STDFMT(CF_OWNERDISPLAY)
            STDFMT(CF_PALETTE)
            STDFMT(CF_PENDATA)
            STDFMT(CF_RIFF)
            STDFMT(CF_SYLK)
            STDFMT(CF_TEXT)
            STDFMT(CF_WAVE)
            STDFMT(CF_TIFF)
            STDFMT(CF_UNICODETEXT)
            default: return L"invalid";
        }
    }

#undef STDFMT
}


/*vector<UINT> Clipboard::getFormats()
{
    vector<UINT> ret;

    Session cbs;
    if (!cbs.isOpened()) {
        error(L"could not open clipboard");
        return ret;
    }

    UINT fmt = 0;
    while ((fmt = EnumClipboardFormats(fmt)) != 0)
        ret.push_back(fmt);
    DWORD err = GetLastError();
    if (err)
        apiError(L"clipboard format enumeration failed", L"EnumClipboardFormats", err);
    return ret;
}*/
