ClipSnappy
==========

A console program that monitors the Clipboard and saves all copied images to disk. Output files can be either BMP (uncompressed) or PNG (compressed).


Requirements
------------

* Visual Studio 2008 or later
* [Boost][]
* [zlib][], [libpng][] (optional; for PNG output support)

[Boost]: http://www.boost.org/
[zlib]: http://zlib.net/
[libpng]: http://libpng.org/pub/png/libpng.html


Building
--------

### Boost

This program requires Boost's `program_options` library, which must be built before use:

1. Download Boost and extract in a directory, e.g. `C:\boost`.
2. In the Boost directory run `bootstrap.bat` to prepare the Boost.Build system (`b2`).
3. Run `.\b2.exe --build-type=complete --with-program_options toolset=msvc-9.0`

About the build arguments:

- `--build-type=complete`: Build all possible library types. ClipSnappy uses static libraries including a static runtime, which `b2` does not built by default.
- `--with-program_options`: Build only the `program_options` library.
- `toolset=msvc-9.0`: Use the MS Visual Studio 2008 tools. If another compiler is used, this should be changed accordingly.

After building, Boost.Build will print the include and library paths that should be added in the project settings.


### zlib / libpng

(TODO:)
